<template>
    <div class="default-main">
        <!-- <TableHeader ref='TableHeaderRef'>
            <template #select>
                <el-form-item label='工程名称'>
                    <el-input v-model='tableStore.table.params.projectName' clearable></el-input>
                </el-form-item>
                <el-form-item label='所属地市'>
                    <el-select v-model='tableStore.table.params.city' clearable placeholder='请选择所属地市'>
                        <el-option
                            v-for='item in areaOptionList'
                            :key='item.id'
                            :label='item.name'
                            :value='item.name'
                        ></el-option>
                    </el-select>
                </el-form-item>
            </template>
            <template #operation>
                <el-button icon='' type='primary' @click='toGoNet()'>{{ titleButton }}</el-button>

                <el-button style='margin-left: 50px' :icon='Back'  @click='go(-1)'>返回</el-button>
            </template>
        </TableHeader> -->
        <div class="header_btn">
            <el-button v-if="bussType==0" icon="" type="primary" @click="toGoNet()">{{ titleButton }}</el-button>
            <el-button v-if="bussType==1&&needGovernance!='0'" icon="" type="primary" @click="toGoNet()">{{ titleButton }}</el-button>
            <el-button style="margin-left: 50px" :icon="Back" @click="go(-1)">返回</el-button>
        </div>
        <Table ref="tableRef" />

        <addForm
            v-if="dialogVisible"
            ref="addForms"
            :id="bussId"
            :bussType="bussType"
            :title="titleButton"
            openType="detail"
            @onSubmit="tableStore.index()"
        ></addForm>
    </div>
</template>

<script setup lang="ts">
defineOptions({
    name: 'ProgramReview'
})

import { ref, onMounted, provide, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useDictData } from '@/stores/dictData'
import addForm from './addForm.vue'
import { useRouter, useRoute } from 'vue-router'
import { Back } from '@element-plus/icons-vue'
const { go, currentRoute, push } = useRouter()
const { query } = useRoute() // 查询参数
const needGovernance = query.needGovernance as unknown as string // 从 URL 传递过来的 是否需要治理
const dictData = useDictData()
const areaOptionList = dictData.getBasicData('jibei_area')
const TableHeaderRef = ref()
const tableStore = new TableStore({
    url: '/supervision-boot/userReportNormal/userReportGoNetPage',

    method: 'POST',
    column: [
        { title: '序号', type: 'seq', width: 80 },
        { field: 'projectName', title: '工程名称', minWidth: 170 },
        {
            field: 'userType',
            title: '用户性质',
            minWidth: 150,
            formatter: (obj: any) => {
                const userType = obj.row.userType
                return getUserTypeName(userType)
            }
        },
        { field: 'city', title: '所属地市', minWidth: 80 },
        { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        { field: 'substation', title: '变电站', minWidth: 100 },
        {
            field: 'status',
            title: '审核状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning'
            },
            replaceValue: {
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消'
            }
        },
        { field: 'createTime', title: '创建时间', minWidth: 100 },
        {
            title: '操作',
            minWidth: 180,
            fixed: 'right',
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        handleAudit(row.processInstanceId)
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.userReportId = bussId.value
        tableStore.table.params.type = bussType.value
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.relationUserName = tableStore.table.params.userName
    }
})
tableStore.table.params.city = ''
tableStore.table.params.projectName = ''

const dialogVisible = ref(false)
const bussId = ref()
bussId.value = currentRoute.value.query.id

const bussType = ref()
bussType.value = Number(currentRoute.value.query.type)

const titleButton = ref()
if (bussType.value === 0) {
    titleButton.value = '入网设计方案申请'
} else {
    titleButton.value = '治理工程申请'
}

provide('tableStore', tableStore)
onMounted(() => {
    tableStore.index()
})

/** 处理审批按钮 */
const handleAudit = (instanceId: any) => {
    push({
        name: 'BpmProcessInstanceDetail',
        query: {
            id: instanceId
        }
    })
}

const addForms = ref()
const toGoNet = () => {
    dialogVisible.value = true
    setTimeout(() => {
        addForms.value.open()
    }, 0)
}

/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}
</script>
<style scoped lang="scss">
.header_btn {
    width: 100%;
    height: 60px;
    display: flex;
    padding: 13px 15px;
    justify-content: flex-end;
    align-items: center;
    border: 1px solid #dddfe6;
}
</style>
